#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "actions.h"

#include <linux/soundcard.h>
#include <stdio.h>                      
#include <fcntl.h>                      
#include <string.h>
#include <stdlib.h>
                     
 
StereoVolume vol;
extern int mixer_fd;                    
char tmpstring[30];
char tmpstring2[10];
                                        
extern guint status_message_context_id;
extern GtkWidget *statusbar1;
extern struct originalset orig;
extern GtkAdjustment *vol_adjustment;
extern GtkAdjustment *pcm_adjustment;
extern GtkAdjustment *speaker_adjustment;
extern GtkAdjustment *cd_adjustment;
extern GtkAdjustment *mic_adjustment;
extern GtkAdjustment *line1_adjustment;


void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
  printf("exiting\n");
  gtk_main_quit();
}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  load_from_file(mixer_fd);
  get_current_levels();
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  save_to_file(mixer_fd);
}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  printf("exiting\n");
  gtk_main_quit();
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  printf("volume control by Rob Eberts.\n");

}


gboolean
on_spinbutton1_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  /* main volume */

  GtkSpinButton *spin;
  extern GtkWidget *spinbutton1;
  spin = GTK_SPIN_BUTTON (spinbutton1);

  vol.left=vol.right = (int) gtk_spin_button_get_value_as_int (spin);
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_VOLUME), &vol);
  strcpy(tmpstring,"main volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_spinbutton2_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  GtkSpinButton *spin;
  extern GtkWidget *spinbutton2;        
  spin = GTK_SPIN_BUTTON (spinbutton2);

  vol.left=vol.right = (int) gtk_spin_button_get_value_as_int (spin);
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_VOLUME), &vol);
  strcpy(tmpstring,"main volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_spinbutton3_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  GtkSpinButton *spin;
  extern GtkWidget *spinbutton3;        
  spin = GTK_SPIN_BUTTON (spinbutton3);

  vol.left=vol.right = (int) gtk_spin_button_get_value_as_int (spin);
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_VOLUME), &vol);
  strcpy(tmpstring,"main volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_spinbutton4_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  GtkSpinButton *spin;
  extern GtkWidget *spinbutton4;        
  spin = GTK_SPIN_BUTTON (spinbutton4);

  vol.left=vol.right = (int) gtk_spin_button_get_value_as_int (spin);
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_VOLUME), &vol);
  strcpy(tmpstring,"main volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_spinbutton5_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  GtkSpinButton *spin;
  extern GtkWidget *spinbutton5;        
  spin = GTK_SPIN_BUTTON (spinbutton5);

  vol.left=vol.right = (int) gtk_spin_button_get_value_as_int (spin);
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_VOLUME), &vol);
  strcpy(tmpstring,"main volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_spinbutton6_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  GtkSpinButton *spin;
  extern GtkWidget *spinbutton6;        
  spin = GTK_SPIN_BUTTON (spinbutton6);

  vol.left=vol.right = (int) gtk_spin_button_get_value_as_int (spin);
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_VOLUME), &vol);
  strcpy(tmpstring,"main volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_vscale1_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  /* main volume */
  vol.left=vol.right=(int) gtk_adjustment_get_value(GTK_ADJUSTMENT(user_data));
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_VOLUME), &vol);
  strcpy(tmpstring,"main volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_vscale2_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  /* pcm */
  vol.left=vol.right=(int) gtk_adjustment_get_value(GTK_ADJUSTMENT(user_data));
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_PCM), &vol);
  
  strcpy(tmpstring,"pcm set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_vscale3_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  /* speaker */
  vol.left=vol.right=(int) gtk_adjustment_get_value(GTK_ADJUSTMENT(user_data));
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_SPEAKER), &vol);

  strcpy(tmpstring,"speaker volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_vscale4_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  /* cd */
  vol.left=vol.right=(int) gtk_adjustment_get_value(GTK_ADJUSTMENT(user_data));
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_CD), &vol);
  
  strcpy(tmpstring,"cd volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_vscale5_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  /* microphone input */
  vol.left=vol.right=(int) gtk_adjustment_get_value(GTK_ADJUSTMENT(user_data));
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_MIC), &vol);
    
  strcpy(tmpstring,"mic volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}


gboolean
on_vscale6_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  /* line1 */
  vol.left=vol.right=(int) gtk_adjustment_get_value(GTK_ADJUSTMENT(user_data));
  ioctl(mixer_fd,MIXER_WRITE(SOUND_MIXER_LINE1), &vol);

  strcpy(tmpstring,"line1 volume set to ");
  sprintf(tmpstring2,"%d",vol.left);
  strcat(tmpstring,tmpstring2);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,tmpstring);

  return FALSE;
}

