
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"


#include <linux/soundcard.h>
#include <fcntl.h>

extern int mixer_fd;
typedef struct stereovolume
{
  unsigned char left;
  unsigned char right;
} StereoVolume;
StereoVolume tmpvol;

struct originalset orig;


GtkWidget *window1;
GtkWidget *vbox1;
GtkWidget *menubar1;
GtkWidget *menuitem1;
GtkWidget *menuitem1_menu;
GtkWidget *open1;
GtkWidget *save1;
GtkWidget *separatormenuitem1;
GtkWidget *quit1;
GtkWidget *menuitem4;
GtkWidget *menuitem4_menu;
GtkWidget *about1;
GtkWidget *hbox1;
GtkWidget *spinbutton1;
GtkWidget *spinbutton2;
GtkWidget *spinbutton3;
GtkWidget *spinbutton4;
GtkWidget *spinbutton5;
GtkWidget *spinbutton6;
GtkWidget *hbox2;
GtkWidget *label1;
GtkWidget *label2;
GtkWidget *label3;
GtkWidget *label4;
GtkWidget *label5;
GtkWidget *label6;
GtkWidget *hbox3;
GtkWidget *vscale1;
GtkWidget *vscale2;
GtkWidget *vscale3;
GtkWidget *vscale4;
GtkWidget *vscale5;
GtkWidget *vscale6;
GtkWidget *statusbar1;
GtkAccelGroup *accel_group;
GtkAdjustment *vol_adjustment;
GtkAdjustment *pcm_adjustment;
GtkAdjustment *speaker_adjustment;
GtkAdjustment *cd_adjustment;
GtkAdjustment *mic_adjustment;
GtkAdjustment *line1_adjustment;
guint status_message_context_id;




GtkWidget*
create_window1 (void)
{

  accel_group = gtk_accel_group_new ();

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_size_request (window1, 485, 300);
  gtk_container_set_border_width (GTK_CONTAINER (window1), 2);
  gtk_window_set_title (GTK_WINDOW (window1), (const gchar *) "volume control");
  gtk_window_set_resizable (GTK_WINDOW (window1), FALSE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);

  menuitem1 = gtk_menu_item_new_with_mnemonic ((const gchar *) "_File");
  gtk_widget_show (menuitem1);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem1);

  menuitem1_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem1), menuitem1_menu);

  open1 = gtk_image_menu_item_new_from_stock ("gtk-open", accel_group);
  gtk_widget_show (open1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), open1);

  save1 = gtk_image_menu_item_new_from_stock ("gtk-save", accel_group);
  gtk_widget_show (save1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), save1);

  separatormenuitem1 = gtk_separator_menu_item_new ();
  gtk_widget_show (separatormenuitem1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), separatormenuitem1);
  gtk_widget_set_sensitive (separatormenuitem1, FALSE);

  quit1 = gtk_image_menu_item_new_from_stock ("gtk-quit", accel_group);
  gtk_widget_show (quit1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), quit1);

  menuitem4 = gtk_menu_item_new_with_mnemonic ((const gchar *) "_Help");
  gtk_widget_show (menuitem4);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem4);

  menuitem4_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem4), menuitem4_menu);

  about1 = gtk_menu_item_new_with_mnemonic ((const gchar *) "_About");
  gtk_widget_show (about1);
  gtk_container_add (GTK_CONTAINER (menuitem4_menu), about1);






  vol_adjustment=GTK_ADJUSTMENT (gtk_adjustment_new (1, 0, 100, 1, 10, 0));
  pcm_adjustment=GTK_ADJUSTMENT (gtk_adjustment_new (1, 0, 100, 1, 10, 0));
  speaker_adjustment=GTK_ADJUSTMENT (gtk_adjustment_new (1, 0, 100, 1, 10, 0));
  cd_adjustment=GTK_ADJUSTMENT (gtk_adjustment_new (1, 0, 100, 1, 10, 0));
  line1_adjustment=GTK_ADJUSTMENT (gtk_adjustment_new (1, 0, 100, 1, 10, 0));
  mic_adjustment=GTK_ADJUSTMENT (gtk_adjustment_new (1, 0, 100, 1, 10, 0));


  /* get original adjustments */
  get_current_levels();






  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, FALSE, TRUE, 8);


  spinbutton1 = gtk_spin_button_new (GTK_ADJUSTMENT (vol_adjustment),1,0); /* ajustment, climb rate, digits */
  gtk_widget_show (spinbutton1);
  gtk_box_pack_start (GTK_BOX (hbox1), spinbutton1, TRUE, FALSE, 0);
  gtk_widget_set_size_request (spinbutton1, -1, 22);
  g_signal_connect ((gpointer) spinbutton1, "value_changed",
                    G_CALLBACK (on_spinbutton1_button_release_event),
                    NULL);
  g_object_set_data_full(G_OBJECT (window1), "spinbutton1",gtk_widget_ref (spinbutton1),(GDestroyNotify) gtk_widget_unref);

  spinbutton2 = gtk_spin_button_new (GTK_ADJUSTMENT (pcm_adjustment),1,0);
  gtk_widget_show (spinbutton2);
  gtk_box_pack_start (GTK_BOX (hbox1), spinbutton2, TRUE, FALSE, 0);
  gtk_widget_set_size_request (spinbutton2, -1, 22);

  spinbutton3 = gtk_spin_button_new (GTK_ADJUSTMENT (speaker_adjustment),1,0);
  gtk_widget_show (spinbutton3);
  gtk_box_pack_start (GTK_BOX (hbox1), spinbutton3, TRUE, FALSE, 0);
  gtk_widget_set_size_request (spinbutton3, -1, 22);

  spinbutton4 = gtk_spin_button_new (GTK_ADJUSTMENT (cd_adjustment),1,0);
  gtk_widget_show (spinbutton4);
  gtk_box_pack_start (GTK_BOX (hbox1), spinbutton4, TRUE, FALSE, 0);
  gtk_widget_set_size_request (spinbutton4, -1, 22);

  spinbutton5 = gtk_spin_button_new (GTK_ADJUSTMENT (mic_adjustment),1,0);
  gtk_widget_show (spinbutton5);
  gtk_box_pack_start (GTK_BOX (hbox1), spinbutton5, TRUE, FALSE, 0);
  gtk_widget_set_size_request (spinbutton5, -1, 22);

  spinbutton6 = gtk_spin_button_new (GTK_ADJUSTMENT (line1_adjustment),1,0);
  gtk_widget_show (spinbutton6);
  gtk_box_pack_start (GTK_BOX (hbox1), spinbutton6, TRUE, FALSE, 0);
  gtk_widget_set_size_request (spinbutton6, -1, 22);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, FALSE, 3);

  label1 = gtk_label_new ((const gchar *) "main");
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox2), label1, TRUE, TRUE, 0);
  gtk_widget_set_size_request (label1, 50, -1);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_CENTER);

  label2 = gtk_label_new ((const gchar *) "pcm");
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox2), label2, TRUE, TRUE, 0);
  gtk_widget_set_size_request (label2, 50, -1);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_CENTER);

  label3 = gtk_label_new ((const gchar *) "speaker");
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox2), label3, TRUE, TRUE, 0);
  gtk_widget_set_size_request (label3, 50, -1);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_CENTER);

  label4 = gtk_label_new ((const gchar *) "cdrom");
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox2), label4, TRUE, TRUE, 0);
  gtk_widget_set_size_request (label4, 50, -1);

  label5 = gtk_label_new ((const gchar *) "mic");
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (hbox2), label5, TRUE, TRUE, 0);
  gtk_widget_set_size_request (label5, 50, -1);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_CENTER);

  label6 = gtk_label_new ((const gchar *) "line1");
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (hbox2), label6, TRUE, TRUE, 0);
  gtk_widget_set_size_request (label6, 50, -1);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_CENTER);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 5);

  vscale1 = gtk_vscale_new (GTK_ADJUSTMENT (vol_adjustment));
  gtk_widget_show (vscale1);
  gtk_range_set_inverted (GTK_RANGE (vscale1), TRUE);
  gtk_box_pack_start (GTK_BOX (hbox3), vscale1, TRUE, TRUE, 0);
  gtk_scale_set_draw_value (GTK_SCALE (vscale1), FALSE);
  g_signal_connect ((gpointer) vscale1, "button_release_event",
                    G_CALLBACK (on_vscale1_button_release_event),
                    vol_adjustment);
  g_object_set_data_full(G_OBJECT (window1), "vscale1",gtk_widget_ref (vscale1),(GDestroyNotify) gtk_widget_unref);


  vscale2 = gtk_vscale_new (GTK_ADJUSTMENT (pcm_adjustment));
  gtk_widget_show (vscale2);
  gtk_range_set_inverted (GTK_RANGE (vscale2), TRUE);
  gtk_box_pack_start (GTK_BOX (hbox3), vscale2, TRUE, TRUE, 0);
  gtk_scale_set_draw_value (GTK_SCALE (vscale2), FALSE);
  g_signal_connect ((gpointer) vscale2, "button_release_event",
                    G_CALLBACK (on_vscale2_button_release_event),
                    pcm_adjustment);
  g_object_set_data_full(G_OBJECT (window1), "vscale2",gtk_widget_ref (vscale2),(GDestroyNotify) gtk_widget_unref);


  vscale3 = gtk_vscale_new (GTK_ADJUSTMENT (speaker_adjustment));
  gtk_widget_show (vscale3);
  gtk_range_set_inverted (GTK_RANGE (vscale3), TRUE);
  gtk_box_pack_start (GTK_BOX (hbox3), vscale3, TRUE, TRUE, 0);
  gtk_scale_set_draw_value (GTK_SCALE (vscale3), FALSE);
  g_signal_connect ((gpointer) vscale3, "button_release_event",
                    G_CALLBACK (on_vscale3_button_release_event),
                    speaker_adjustment);
  g_object_set_data_full(G_OBJECT (window1), "vscale3",gtk_widget_ref (vscale3),(GDestroyNotify) gtk_widget_unref);

  vscale4 = gtk_vscale_new (GTK_ADJUSTMENT (cd_adjustment));
  gtk_widget_show (vscale4);
  gtk_range_set_inverted (GTK_RANGE (vscale4), TRUE);
  gtk_box_pack_start (GTK_BOX (hbox3), vscale4, TRUE, TRUE, 0);
  gtk_scale_set_draw_value (GTK_SCALE (vscale4), FALSE);
  g_signal_connect ((gpointer) vscale4, "button_release_event",
                    G_CALLBACK (on_vscale4_button_release_event),
                    cd_adjustment);
  g_object_set_data_full(G_OBJECT (window1), "vscale4",gtk_widget_ref (vscale4),(GDestroyNotify) gtk_widget_unref);

  vscale5 = gtk_vscale_new (GTK_ADJUSTMENT (mic_adjustment));
  gtk_widget_show (vscale5);
  gtk_range_set_inverted (GTK_RANGE (vscale5), TRUE);
  gtk_box_pack_start (GTK_BOX (hbox3), vscale5, TRUE, TRUE, 0);
  gtk_scale_set_draw_value (GTK_SCALE (vscale5), FALSE);
  g_signal_connect ((gpointer) vscale5, "button_release_event",
                    G_CALLBACK (on_vscale5_button_release_event),
                    mic_adjustment);
  g_object_set_data_full(G_OBJECT (window1), "vscale5",gtk_widget_ref (vscale5),(GDestroyNotify) gtk_widget_unref);

  vscale6 = gtk_vscale_new (GTK_ADJUSTMENT (line1_adjustment));
  gtk_widget_show (vscale6);
  gtk_range_set_inverted (GTK_RANGE (vscale6), TRUE);
  gtk_box_pack_start (GTK_BOX (hbox3), vscale6, TRUE, TRUE, 0);
  gtk_scale_set_draw_value (GTK_SCALE (vscale6), FALSE);
  g_signal_connect ((gpointer) vscale6, "button_release_event",
                    G_CALLBACK (on_vscale6_button_release_event),
                    line1_adjustment);
  g_object_set_data_full(G_OBJECT (window1), "vscale6",gtk_widget_ref (vscale6),(GDestroyNotify) gtk_widget_unref);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_set_name (statusbar1, "statusbar1");
  gtk_widget_show (statusbar1);
  gtk_box_pack_start (GTK_BOX (vbox1), statusbar1, FALSE, FALSE, 0);
  gtk_statusbar_set_has_resize_grip (GTK_STATUSBAR (statusbar1), FALSE);
  gtk_statusbar_push(GTK_STATUSBAR(statusbar1), status_message_context_id,"current settings loaded");

  g_signal_connect ((gpointer) window1, "destroy",
                    G_CALLBACK (on_window1_destroy),
                    NULL);
  g_signal_connect ((gpointer) open1, "activate",
                    G_CALLBACK (on_open1_activate),
                    NULL);
  g_signal_connect ((gpointer) save1, "activate",
                    G_CALLBACK (on_save1_activate),
                    NULL);
  g_signal_connect ((gpointer) quit1, "activate",
                    G_CALLBACK (on_quit1_activate),
                    NULL);
  g_signal_connect ((gpointer) about1, "activate",
                    G_CALLBACK (on_about1_activate),
                    NULL);


  g_object_set_data (G_OBJECT (window1), "window1", window1);
  g_object_set_data_full (G_OBJECT (window1), "menubar1",gtk_widget_ref (menubar1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "vbox1",gtk_widget_ref (vbox1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "menubar1",gtk_widget_ref (menubar1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "menuitem1_menu",gtk_widget_ref (menuitem1_menu), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "open1",gtk_widget_ref (open1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "save1",gtk_widget_ref (save1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "separatormenuitem1",gtk_widget_ref (separatormenuitem1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "quit1",gtk_widget_ref (quit1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "menuitem4",gtk_widget_ref (menuitem4), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "menuitem4_menu",gtk_widget_ref (menuitem4_menu), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "about1",gtk_widget_ref (about1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "hbox1",gtk_widget_ref (hbox1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "hbox2",gtk_widget_ref (hbox2), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "hbox3",gtk_widget_ref (hbox3), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "label1",gtk_widget_ref (label1), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "label2",gtk_widget_ref (label2), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "label3",gtk_widget_ref (label3), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "label4",gtk_widget_ref (label4), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "label5",gtk_widget_ref (label5), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full (G_OBJECT (window1), "label6",gtk_widget_ref (label6), (GDestroyNotify) gtk_widget_unref);
  g_object_set_data_full(G_OBJECT (window1), "statusbar1",gtk_widget_ref (statusbar1), (GDestroyNotify) gtk_widget_unref);

  gtk_window_add_accel_group (GTK_WINDOW (window1), accel_group);

  return window1;
}



void get_current_levels() {
  ioctl(mixer_fd,MIXER_READ(SOUND_MIXER_VOLUME), &tmpvol);
  orig.mainvol=tmpvol.left;
  gtk_adjustment_set_value(GTK_ADJUSTMENT(vol_adjustment), (double) tmpvol.left);

  ioctl(mixer_fd,MIXER_READ(SOUND_MIXER_PCM), &tmpvol);
  orig.pcm=tmpvol.left;
  gtk_adjustment_set_value(GTK_ADJUSTMENT(pcm_adjustment), (double) tmpvol.left);
  
  ioctl(mixer_fd,MIXER_READ(SOUND_MIXER_SPEAKER), &tmpvol);
  orig.speaker=tmpvol.left;
  gtk_adjustment_set_value(GTK_ADJUSTMENT(speaker_adjustment), (double) tmpvol.left);

  ioctl(mixer_fd,MIXER_READ(SOUND_MIXER_CD), &tmpvol);
  orig.cd=tmpvol.left;
  gtk_adjustment_set_value(GTK_ADJUSTMENT(cd_adjustment), (double) tmpvol.left);

  ioctl(mixer_fd,MIXER_READ(SOUND_MIXER_MIC), &tmpvol);
  orig.mic=tmpvol.left;
  gtk_adjustment_set_value(GTK_ADJUSTMENT(mic_adjustment), (double) tmpvol.left);
  
  ioctl(mixer_fd,MIXER_READ(SOUND_MIXER_LINE1), &tmpvol);
  orig.line1=tmpvol.left;
  gtk_adjustment_set_value(GTK_ADJUSTMENT(line1_adjustment), (double) tmpvol.left);
}
