
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include "interface.h"
#include "actions.h"
#include <fcntl.h>

int mixer_fd;

int
main (int argc, char *argv[])
{

  mixer_fd = open ("/dev/mixer", O_RDWR, 0);
  if (mixer_fd < 0)
    printf ("Error opening mixer device\n"), exit (1);


  if (argc > 1) 
  {
    args(argc, argv);
    return 0;
  }


  GtkWidget *window1;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  window1 = create_window1 ();
  gtk_widget_show (window1);

  gtk_main ();

  close(mixer_fd);
  return 0;
}

